<?php

require_once("binary.php");

function write_wav($fn,$sm,$sr){
	$sc=strlen($sm);
	if($sc&1) $sm.="\x00";
	$o="RIFF".int42str($sc+36)."WAVEfmt ".int42str(16).int22str(1).int22str(1).int42str($sr).int42str($sr).int22str(1).int22str(8)."data".int42str($sc).$sm;
	$fp=fopen($fn.".wav","wb"); fwrite($fp,$o); fclose($fp);
}

function parse_sound_header($f,$p){
	$samplePtr = getint4mac($f,$p);
	$length = getint4mac($f,$p);
	$sampleRate = getint4mac($f,$p) / 0x10000;
	$loopStart = getint4mac($f,$p);
	$loopEnd = getint4mac($f,$p);
	$encode = getint1($f,$p);
	$baseFrequency = getint1($f,$p);
	if($samplePtr===0){
		$samples=getstr($f,$p,$length);
	}else{
		printf("samplePtr = 0x%08X, not zero\r\n",$samplePtr);
	}
	//printf("wave...\r\n");
	global $fn;
	static $index=0;
	write_wav($fn."_".$index,$samples,$sampleRate);
	++$index;
}

function parse_snd_command($f,$p){
	$cmd = getint2mac($f,$p);
	$data_offset = ($cmd&0x8000)!==0;
	$cmd &= 0x7FFF;
	$param1 = getint2mac($f,$p);
	$param2 = getint4mac($f,$p);
	switch($cmd){
		case 80: // soundCmd
			parse_sound_header($f,$param2);
		break;
		default:
			printf("Unknown cmd: %d\r\n",$cmd);
		break;
	}
}

function parse_snd_res($f){
	$p=0;
	$format = getint2mac($f,$p);
	switch($format){
		case 2:
			$reference_count = getint2mac($f,$p);
			$n_commands = getint2mac($f,$p);
			for ($i=0; $i<$n_commands; ++$i) {
				parse_snd_command($f,$p);
			}
		break;
		default:
			die("Unsupported snd format: ".$format);
		break;
	}
}

$fn=$argv[1] or die("no arg?");
$f=file_get_contents($fn) or die("no file?");

parse_snd_res($f);
